gi-atk-2.0.28: Atk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Atk.Interfaces.Document

Contents

- Exported types
- Methods
  - getAttributeValue
  - getAttributes
  - getCurrentPageNumber
  - getDocument
  - getDocumentType
  - getLocale
  - getPageCount
  - getTextSelections
  - setAttributeValue
  - setTextSelections
- Signals
  - documentAttributeChanged
  - loadComplete
  - loadStopped
  - pageChanged
  - reload

Description

The ATK interface which represents the toplevel container for document content.

The AtkDocument interface should be supported by any object whose content is a representation or view of a document. The AtkDocument interface should appear on the toplevel container for the document content; however AtkDocument instances may be nested (i.e. an AtkDocument may be a descendant of another AtkDocument) in those cases where one document contains "embedded content" which can reasonably be considered a document in its own right.

Synopsis

- newtype Document = Document (ManagedPtr Document)
- class (GObject o, IsDescendantOf Document o) => IsDocument o
- toDocument :: (MonadIO m, IsDocument o) => o -> m Document
- documentGetAttributeValue :: (HasCallStack, MonadIO m, IsDocument a) => a -> Text -> m (Maybe Text)
- documentGetAttributes :: (HasCallStack, MonadIO m, IsDocument a) => a -> m [Ptr ()]
- documentGetCurrentPageNumber :: (HasCallStack, MonadIO m, IsDocument a) => a -> m Int32
- documentGetDocument :: (HasCallStack, MonadIO m, IsDocument a) => a -> m (Ptr ())
- documentGetDocumentType :: (HasCallStack, MonadIO m, IsDocument a) => a -> m Text
- documentGetLocale :: (HasCallStack, MonadIO m, IsDocument a) => a -> m Text
- documentGetPageCount :: (HasCallStack, MonadIO m, IsDocument a) => a -> m Int32
- documentGetTextSelections :: (HasCallStack, MonadIO m, IsDocument a) => a -> m [TextSelection]
- documentSetAttributeValue :: (HasCallStack, MonadIO m, IsDocument a) => a -> Text -> Text -> m Bool
- documentSetTextSelections :: (HasCallStack, MonadIO m, IsDocument a) => a -> [TextSelection] -> m Bool
- type DocumentDocumentAttributeChangedCallback = Text -> Text -> IO ()
- afterDocumentDocumentAttributeChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentDocumentAttributeChangedCallback) -> m SignalHandlerId
- onDocumentDocumentAttributeChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentDocumentAttributeChangedCallback) -> m SignalHandlerId
- type DocumentLoadCompleteCallback = IO ()
- afterDocumentLoadComplete :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadCompleteCallback) -> m SignalHandlerId
- onDocumentLoadComplete :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadCompleteCallback) -> m SignalHandlerId
- type DocumentLoadStoppedCallback = IO ()
- afterDocumentLoadStopped :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadStoppedCallback) -> m SignalHandlerId
- onDocumentLoadStopped :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadStoppedCallback) -> m SignalHandlerId
- type DocumentPageChangedCallback = Int32 -> IO ()
- afterDocumentPageChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentPageChangedCallback) -> m SignalHandlerId
- onDocumentPageChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentPageChangedCallback) -> m SignalHandlerId
- type DocumentReloadCallback = IO ()
- afterDocumentReload :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentReloadCallback) -> m SignalHandlerId
- onDocumentReload :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentReloadCallback) -> m SignalHandlerId

# Exported types

newtype Document Source #

Memory-managed wrapper type.

Constructors

Document (ManagedPtr Document) |

#### Instances

Instances details

Eq Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document Methods (==) :: Document -> Document -> Bool Source # (/=) :: Document -> Document -> Bool Source #
GObject Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document
ManagedPtrNewtype Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document Methods toManagedPtr :: Document -> ManagedPtr Document Source #
TypedObject Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document Methods glibType :: IO GType Source #
HasParentTypes Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document
IsGValue (Maybe Document) Source # | Convert `Document` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Atk.Interfaces.Document Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Document -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Document) Source #
type ParentTypes Document Source # |
Instance details Defined in GI.Atk.Interfaces.Document type ParentTypes Document = '[Object]

class (GObject o, IsDescendantOf Document o) => IsDocument o Source #

Type class for types which can be safely cast to `Document`, for instance with `toDocument`.

#### Instances

Instances details

(GObject o, IsDescendantOf Document o) => IsDocument o Source # |
Instance details Defined in GI.Atk.Interfaces.Document

toDocument :: (MonadIO m, IsDocument o) => o -> m Document Source #

Cast to `Document`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getAttributeValue, getAttributes, getCurrentPageNumber, getData, getDocument, getDocumentType, getLocale, getPageCount, getProperty, getQdata, getTextSelections.

#### Setters

setAttributeValue, setData, setDataFull, setProperty, setTextSelections.

## getAttributeValue

documentGetAttributeValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements AtkDocumentIface
-> Text | `attributeName`: a character string representing the name of the attribute whose value is being queried.
-> m (Maybe Text) | Returns: a string value associated with the named attribute for this document, or `Nothing` if a value for `attributeName` has not been specified for this document.

Retrieves the value of the given `attributeName` inside `document`.

Since: 1.12

## getAttributes

documentGetAttributes Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements AtkDocumentIface
-> m [Ptr ()] | Returns: An AtkAttributeSet containing the explicitly set name-value-pair attributes associated with this document as a whole.

Gets an AtkAttributeSet which describes document-wide attributes as name-value pairs.

Since: 1.12

## getCurrentPageNumber

documentGetCurrentPageNumber Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: the `Document`
-> m Int32 | Returns: the current page number inside `document`, or -1 if not implemented, not know by the implementor, or irrelevant.

Retrieves the current page number inside `document`.

Since: 2.12

## getDocument

documentGetDocument Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements AtkDocumentIface
-> m (Ptr ()) | Returns: a `gpointer` that points to an instance of the DOM.

Deprecated: Since 2.12. `document` is already a representation ofthe document. Use it directly, or one of its children, as aninstance of the DOM.

Gets a `gpointer` that points to an instance of the DOM. It is up to the caller to check atk_document_get_type to determine how to cast this pointer.

## getDocumentType

documentGetDocumentType Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements AtkDocumentIface
-> m Text | Returns: a string indicating the document type

Deprecated: Since 2.12. Please use `documentGetAttributes` toask for the document type if it applies.

Gets a string indicating the document type.

## getLocale

documentGetLocale Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements AtkDocumentIface
-> m Text | Returns: a UTF-8 string indicating the POSIX-style LC_MESSAGES locale of the document content as a whole, or NULL if the document content does not specify a locale.

Deprecated: (Since version 2.7.90)Please use `objectGetObjectLocale` instead.

Gets a UTF-8 string indicating the POSIX-style LC_MESSAGES locale of the content of this document instance. Individual text substrings or images within this document may have a different locale, see atk_text_get_attributes and atk_image_get_image_locale.

## getPageCount

documentGetPageCount Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: the `Document`
-> m Int32 | Returns: total page count of `document`, or -1 if not implemented, not know by the implementor or irrelevant.

Retrieves the total number of pages inside `document`.

Since: 2.12

## getTextSelections

documentGetTextSelections Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: an `Document`
-> m [TextSelection] | Returns: a GArray of AtkTextSelection structures representing the selection.

Returns an array of AtkTextSelections within this document.

Since: 2.52

## setAttributeValue

documentSetAttributeValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: a `Object` instance that implements `DocumentIface`
-> Text | `attributeName`: a character string representing the name of the attribute whose value is being set.
-> Text | `attributeValue`: a string value to be associated with `attributeName`.
-> m Bool | Returns: `True` if `attributeValue` is successfully associated with `attributeName` for this `document`, and `False` if if the document does not allow the attribute to be modified

Sets the value for the given `attributeName` inside `document`.

Since: 1.12

## setTextSelections

documentSetTextSelections Source #

Arguments

:: (HasCallStack, MonadIO m, IsDocument a) |
=> a | `document`: an `Document`.
-> [TextSelection] | `selections`: a GArray of AtkTextSelections to be selected.
-> m Bool | Returns: TRUE if the selection was made successfully; FALSE otherwise.

Makes 1 or more selections within this document denoted by the given array of AtkTextSelections. Any existing physical selection (inside or outside this document) is replaced by the new selections. All objects within the given selection ranges must be descendants of this document. Otherwise FALSE will be returned.

Since: 2.52

# Signals

## documentAttributeChanged

type DocumentDocumentAttributeChangedCallback Source #

Arguments

= Text | `arg1`: the name of the attribute being modified, or `Nothing` if not available.
-> Text | `arg2`: the attribute's new value, or `null` if not available.
-> IO () |

The "document-attribute-changed" signal should be emitted when there is a change to one of the document attributes returned by atk_document_get_attributes.

Since: 2.52

afterDocumentDocumentAttributeChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentDocumentAttributeChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the documentAttributeChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after document #documentAttributeChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onDocumentDocumentAttributeChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentDocumentAttributeChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the documentAttributeChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on document #documentAttributeChanged callback

## loadComplete

type DocumentLoadCompleteCallback = IO () Source #

The 'load-complete' signal is emitted when a pending load of a static document has completed. This signal is to be expected by ATK clients if and when AtkDocument implementors expose ATK_STATE_BUSY. If the state of an AtkObject which implements AtkDocument does not include ATK_STATE_BUSY, it should be safe for clients to assume that the AtkDocument's static contents are fully loaded into the container. (Dynamic document contents should be exposed via other signals.)

afterDocumentLoadComplete :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadCompleteCallback) -> m SignalHandlerId Source #

Connect a signal handler for the loadComplete signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after document #loadComplete callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onDocumentLoadComplete :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadCompleteCallback) -> m SignalHandlerId Source #

Connect a signal handler for the loadComplete signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on document #loadComplete callback

## loadStopped

type DocumentLoadStoppedCallback = IO () Source #

The 'load-stopped' signal is emitted when a pending load of document contents is cancelled, paused, or otherwise interrupted by the user or application logic. It should not however be emitted while waiting for a resource (for instance while blocking on a file or network read) unless a user-significant timeout has occurred.

afterDocumentLoadStopped :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadStoppedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the loadStopped signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after document #loadStopped callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onDocumentLoadStopped :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentLoadStoppedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the loadStopped signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on document #loadStopped callback

## pageChanged

type DocumentPageChangedCallback Source #

Arguments

= Int32 | `pageNumber`: the new page number. If this value is unknown or not applicable, -1 should be provided.
-> IO () |

The 'page-changed' signal is emitted when the current page of a document changes, e.g. pressing page up/down in a document viewer.

Since: 2.12

afterDocumentPageChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentPageChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the pageChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after document #pageChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onDocumentPageChanged :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentPageChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the pageChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on document #pageChanged callback

## reload

type DocumentReloadCallback = IO () Source #

The 'reload' signal is emitted when the contents of a document is refreshed from its source. Once 'reload' has been emitted, a matching 'load-complete' or 'load-stopped' signal should follow, which clients may await before interrogating ATK for the latest document content.

afterDocumentReload :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentReloadCallback) -> m SignalHandlerId Source #

Connect a signal handler for the reload signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after document #reload callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onDocumentReload :: (IsDocument a, MonadIO m) => a -> ((?self :: a) => DocumentReloadCallback) -> m SignalHandlerId Source #

Connect a signal handler for the reload signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on document #reload callback